.xcref BIOSDATA,RS232_BASE,PRINTER_BASE,EQUIP_FLAG,MFG_TST,MEMORY_SIZE
.xcref MFG_ERR_FLAG,KB_FLAG,KB_FLAG1,ALT_INPUT,BUFFER_HEAD,BUFFER_TAIL
.xcref KB_BUFFER,KB_BUFFER_END,SEEK_STATUS,MOTOR_STATUS,MOTOR_COUNT
.xcref DISKETTE_STATUS,CMD_BLOCK,HD_ERROR,NEC_STATUS,CRT_MODE,CRT_COLS
.xcref CRT_LEN,CRT_START,CURSOR_POSN,CURSOR_MODE,ACTIVE_PAGE,ADDR_6845
.xcref CRT_MODE_SET,CRT_PALLETTE,IO_ROM_INIT,IO_ROM_SEG,INTR_FLAG
.xcref TIMER_LOW,TIMER_HIGH,TIMER_OFL,BIOS_BREAK,RESET_FLAG,DISK_STATUS1
.xcref HF_NUM,CONTROL_BYTE,PORT_OFF,PRINT_TIM_OUT,RS232_TIM_OUT,BUFFER_START
.xcref BUFFER_END,LASTRATE,HF_STATUS,HF_ERROR,HF_INT_FLAG,HF_CNTRL,DSK_STATE
.xcref DSK_TRK,KB_FLAG_2,USER_FLAG,USER_FLAG_SEG,RTC_LOW,RTC_HIGH,RTC_WAIT_FLAG
.xcref INTRA_APP

BIOSDATA segment at 40h 	; Start BIOSDATA segment

RS232_BASE dw	 4 dup (?)	; Addresses of RS232 adapters
PRINTER_BASE dw  4 dup (?)	; Address of printers
EQUIP_FLAG dw	 ?		; Installed hardware
MFG_TST  db	 ?		; Initialization flag
MEMORY_SIZE dw	 ?		; Memory size in K bytes
MFG_ERR_FLAG db  ?		; Scratchpad for manufacturing
	 db	 ?		; Error codes

; Keyboard data areas

KB_FLAG  db	 ?		; Keyboard status
KB_FLAG1 db	 ?		; Second byte of keyboard status
ALT_INPUT db	 ?		; Storage for alternate keypad entry
BUFFER_HEAD dw	 ?		; Pointer to head of keyboard buffer
BUFFER_TAIL dw	 ?		; Pointer to tail of keyboard buffer
KB_BUFFER dw	 16 dup (?)	; Room for 15 entries
KB_BUFFER_END label word

; Diskette data areas

SEEK_STATUS db	 ?		; Drive recalibration status
				; Bit 3-0 = drive 3-0 needs recalibration
				;   before next seek if bit is 0
MOTOR_STATUS db  ?		;
				; Bits 3-0 = drive 3-0 is currently running
				; Bit 7 = current operation is a write,
				;   & requires a delay
MOTOR_COUNT db	 ?		; Time out counter for drive turnoff
DISKETTE_STATUS db ?		; Return code status byte
CMD_BLOCK label  byte
HD_ERROR  label  byte
NEC_STATUS db	 7 dup (?)	; Status bytes from NEC

; Video display data areas

CRT_MODE db	 ?		; Current CRT mode
CRT_COLS dw	 ?		; # columns on screen
CRT_LEN  dw	 ?		; Length of regen in bytes
CRT_START dw	 ?		; Starting address in regen buffer
CURSOR_POSN dw	 8 dup (?)	; Cursor for each of up to 8 pages
CURSOR_MODE dw	 ?		; Current cursor mode setting
ACTIVE_PAGE db	 ?		; Current page being displayed
ADDR_6845 dw	 ?		; Base address for active display card
CRT_MODE_SET db  ?		; Current setting of the 3x8 register
CRT_PALLETTE db  ?		; Current pallette setting for color card

; POST data area

IO_ROM_INIT dw	 ?		; Pointer to optional I/O ROM init routine
IO_ROM_SEG dw	 ?		; Pointer to I/O ROM segment
INTR_FLAG db	 ?		; Flag to indicate an interrupt happened

; Timer data area

TIMER_LOW dw	 ?		; Low word of timer count
TIMER_HIGH dw	 ?		; High word of timer count
TIMER_OFL db	 ?		; Timer has rolled over since last read

; System data area

BIOS_BREAK db	 ?		; Bit 7 = 1 if break key has been hit
RESET_FLAG dw	 ?		; Word=1234h if keyboard reset underway

; Hard file data areas

DISK_STATUS1 db  ?
HF_NUM	 db	 ?		; # hard files
CONTROL_BYTE db  ?
PORT_OFF db	 ?

; Printer and RS232 time-out values

PRINT_TIM_OUT db 4 dup (?)
RS232_TIM_OUT db 4 dup (?)

; Additional keyboard data area

BUFFER_START dw  ?
BUFFER_END dw	 ?

; EGA values

EGA_ROWS db	 ?		; # screen rows
EGA_PNTS dw	 ?		; # bytes per character
EGA_INFO db	 ?		; Information byte
EGA_INF3 db	 ?		; Information byte 3?

; Additional floppy data

	 org	 8Bh
LASTRATE db	 ?		; Last data rate selected

; Additional hard file data

	 org	 8Ch
HF_STATUS db	 ?		; Status register
HF_ERROR db	 ?		; Error register
HF_INT_FLAG db	 ?		; Hard file interrupt flag
HF_CNTRL db	 ?		; Combo hard file/floppy car bit 0=1

; Additional diskette area

	 org	 90h
DSK_STATE label  byte
	 db	 ?		; Drive 0 media state
	 db	 ?		; Drive 1 media state
	 db	 ?		; Drive 0 operation start byte
	 db	 ?		; Drive 1 operation start byte
DSK_TRK  db	 ?		; Drive 0 present cylinder
	 db	 ?		; Drive 1 present cylinder
	 db	 ?		; Reserved

; Additional keyboard LED flags

	 org	 96h
KB_FLAG_3 db	 ?
@KBX	 equ	 00010000b	; Flag for enhanced keyboard
KB_FLAG_2 db	 ?

; Real time clock data area

	 org	 98h
USER_FLAG dw	 ?		; Offset addr of user's wait flag
USER_FLAG_SEG dw ?		; Segment of ...
RTC_LOW  dw	 ?		; Low word of user wait flag
RTC_HIGH dw	 ?		; High word of ...
RTC_WAIT_FLAG db ?		; Wait active flag

; Intra-application communication area for any application

	 org	 0F0h
INTRA_APP db	 16 dup (?)

BIOSDATA ends			; End BIOSDATA segment

.xcref XXBIOSDATA,STATUS_BYTE,SINGLE_DRIVE_MODE

XXBIOSDATA segment at 50h

STATUS_BYTE db	 ?		; Print screen status flag
				; 0 = print screen not active or it
				;     was successful
				; 1 = in progress
				;-1 = error encountered during print screen

	 db	 3 dup (?)	; Reserved
SINGLE_DRIVE_MODE db ?		; Single drive mode status byte

XXBIOSDATA ends

