/* KEYBECHO.C -- Echo keyboard codes */

int  check_enh_keyb(void);
void inst16(void);
void rest16(void);
void instints(void);
void restints(void);
int  getkey(void);

#define EQ ==

char
  int16key = 0x00,
  int16kst = 0x01,
  inst16flg = 0,
  prtscflg = 0,
  syscallflg = 0,
  ;

struct KEY_STR
{
 char
   *name;
 unsigned int
    code;
};

struct KEY_STR
  keys[] = {
{"c-break",        0 + 256 *   0},      {"a-010",         10 + 256 *   0},      {"a-020",         20 + 256 *   0},      {"a-030",         30 + 256 *   0},
{"a-001",          1 + 256 *   0},      {"a-011",         11 + 256 *   0},      {"a-021",         21 + 256 *   0},      {"a-031",         31 + 256 *   0},
{"a-002",          2 + 256 *   0},      {"a-012",         12 + 256 *   0},      {"a-022",         22 + 256 *   0},      {"a-032",         32 + 256 *   0},
{"a-003",          3 + 256 *   0},      {"a-013",         13 + 256 *   0},      {"a-023",         23 + 256 *   0},      {"a-033",         33 + 256 *   0},
{"a-004",          4 + 256 *   0},      {"a-014",         14 + 256 *   0},      {"a-024",         24 + 256 *   0},      {"a-034",         34 + 256 *   0},
{"a-005",          5 + 256 *   0},      {"a-015",         15 + 256 *   0},      {"a-025",         25 + 256 *   0},      {"a-035",         35 + 256 *   0},
{"a-006",          6 + 256 *   0},      {"a-016",         16 + 256 *   0},      {"a-026",         26 + 256 *   0},      {"a-036",         36 + 256 *   0},
{"a-007",          7 + 256 *   0},      {"a-017",         17 + 256 *   0},      {"a-027",         27 + 256 *   0},      {"a-037",         37 + 256 *   0},
{"a-008",          8 + 256 *   0},      {"a-018",         18 + 256 *   0},      {"a-028",         28 + 256 *   0},      {"a-038",         38 + 256 *   0},
{"a-009",          9 + 256 *   0},      {"a-019",         19 + 256 *   0},      {"a-029",         29 + 256 *   0},      {"a-039",         39 + 256 *   0},

{"a-040",         40 + 256 *   0},      {"a-050",         50 + 256 *   0},      {"a-060",         60 + 256 *   0},      {"a-070",         70 + 256 *   0},
{"a-041",         41 + 256 *   0},      {"a-051",         51 + 256 *   0},      {"a-061",         61 + 256 *   0},      {"a-071",         71 + 256 *   0},
{"a-042",         42 + 256 *   0},      {"a-052",         52 + 256 *   0},      {"a-062",         62 + 256 *   0},      {"a-072",         72 + 256 *   0},
{"a-043",         43 + 256 *   0},      {"a-053",         53 + 256 *   0},      {"a-063",         63 + 256 *   0},      {"a-073",         73 + 256 *   0},
{"a-044",         44 + 256 *   0},      {"a-054",         54 + 256 *   0},      {"a-064",         64 + 256 *   0},      {"a-074",         74 + 256 *   0},
{"a-045",         45 + 256 *   0},      {"a-055",         55 + 256 *   0},      {"a-065",         65 + 256 *   0},      {"a-075",         75 + 256 *   0},
{"a-046",         46 + 256 *   0},      {"a-056",         56 + 256 *   0},      {"a-066",         66 + 256 *   0},      {"a-076",         76 + 256 *   0},
{"a-047",         47 + 256 *   0},      {"a-057",         57 + 256 *   0},      {"a-067",         67 + 256 *   0},      {"a-077",         77 + 256 *   0},
{"a-048",         48 + 256 *   0},      {"a-058",         58 + 256 *   0},      {"a-068",         68 + 256 *   0},      {"a-078",         78 + 256 *   0},
{"a-049",         49 + 256 *   0},      {"a-059",         59 + 256 *   0},      {"a-069",         69 + 256 *   0},      {"a-079",         79 + 256 *   0},

{"a-080",         80 + 256 *   0},      {"a-090",         90 + 256 *   0},
{"a-081",         81 + 256 *   0},      {"a-091",         91 + 256 *   0},
{"a-082",         82 + 256 *   0},      {"a-092",         92 + 256 *   0},
{"a-083",         83 + 256 *   0},      {"a-093",         93 + 256 *   0},
{"a-084",         84 + 256 *   0},      {"a-094",         94 + 256 *   0},
{"a-085",         85 + 256 *   0},      {"a-095",         95 + 256 *   0},
{"a-086",         86 + 256 *   0},      {"a-096",         96 + 256 *   0},
{"a-087",         87 + 256 *   0},      {"a-097",         97 + 256 *   0},
{"a-088",         88 + 256 *   0},      {"a-098",         98 + 256 *   0},
{"a-089",         89 + 256 *   0},      {"a-099",         99 + 256 *   0},

{"a-100",        100 + 256 *   0},      {"a-110",        110 + 256 *   0},      {"a-120",        120 + 256 *   0},      {"a-130",        130 + 256 *   0},
{"a-101",        101 + 256 *   0},      {"a-111",        111 + 256 *   0},      {"a-121",        121 + 256 *   0},      {"a-131",        131 + 256 *   0},
{"a-102",        102 + 256 *   0},      {"a-112",        112 + 256 *   0},      {"a-122",        122 + 256 *   0},      {"a-132",        132 + 256 *   0},
{"a-103",        103 + 256 *   0},      {"a-113",        113 + 256 *   0},      {"a-123",        123 + 256 *   0},      {"a-133",        133 + 256 *   0},
{"a-104",        104 + 256 *   0},      {"a-114",        114 + 256 *   0},      {"a-124",        124 + 256 *   0},      {"a-134",        134 + 256 *   0},
{"a-105",        105 + 256 *   0},      {"a-115",        115 + 256 *   0},      {"a-125",        125 + 256 *   0},      {"a-135",        135 + 256 *   0},
{"a-106",        106 + 256 *   0},      {"a-116",        116 + 256 *   0},      {"a-126",        126 + 256 *   0},      {"a-136",        136 + 256 *   0},
{"a-107",        107 + 256 *   0},      {"a-117",        117 + 256 *   0},      {"a-127",        127 + 256 *   0},      {"a-137",        137 + 256 *   0},
{"a-108",        108 + 256 *   0},      {"a-118",        118 + 256 *   0},      {"a-128",        128 + 256 *   0},      {"a-138",        138 + 256 *   0},
{"a-109",        109 + 256 *   0},      {"a-119",        119 + 256 *   0},      {"a-129",        129 + 256 *   0},      {"a-139",        139 + 256 *   0},

{"a-140",        140 + 256 *   0},      {"a-150",        150 + 256 *   0},      {"a-160",        160 + 256 *   0},      {"a-170",        170 + 256 *   0},
{"a-141",        141 + 256 *   0},      {"a-151",        151 + 256 *   0},      {"a-161",        161 + 256 *   0},      {"a-171",        171 + 256 *   0},
{"a-142",        142 + 256 *   0},      {"a-152",        152 + 256 *   0},      {"a-162",        162 + 256 *   0},      {"a-172",        172 + 256 *   0},
{"a-143",        143 + 256 *   0},      {"a-153",        153 + 256 *   0},      {"a-163",        163 + 256 *   0},      {"a-173",        173 + 256 *   0},
{"a-144",        144 + 256 *   0},      {"a-154",        154 + 256 *   0},      {"a-164",        164 + 256 *   0},      {"a-174",        174 + 256 *   0},
{"a-145",        145 + 256 *   0},      {"a-155",        155 + 256 *   0},      {"a-165",        165 + 256 *   0},      {"a-175",        175 + 256 *   0},
{"a-146",        146 + 256 *   0},      {"a-156",        156 + 256 *   0},      {"a-166",        166 + 256 *   0},      {"a-176",        176 + 256 *   0},
{"a-147",        147 + 256 *   0},      {"a-157",        157 + 256 *   0},      {"a-167",        167 + 256 *   0},      {"a-177",        177 + 256 *   0},
{"a-148",        148 + 256 *   0},      {"a-158",        158 + 256 *   0},      {"a-168",        168 + 256 *   0},      {"a-178",        178 + 256 *   0},
{"a-149",        149 + 256 *   0},      {"a-159",        159 + 256 *   0},      {"a-169",        169 + 256 *   0},      {"a-179",        179 + 256 *   0},

{"a-180",        180 + 256 *   0},      {"a-190",        190 + 256 *   0},
{"a-181",        181 + 256 *   0},      {"a-191",        191 + 256 *   0},
{"a-182",        182 + 256 *   0},      {"a-192",        192 + 256 *   0},
{"a-183",        183 + 256 *   0},      {"a-193",        193 + 256 *   0},
{"a-184",        184 + 256 *   0},      {"a-194",        194 + 256 *   0},
{"a-185",        185 + 256 *   0},      {"a-195",        195 + 256 *   0},
{"a-186",        186 + 256 *   0},      {"a-196",        196 + 256 *   0},
{"a-187",        187 + 256 *   0},      {"a-197",        197 + 256 *   0},
{"a-188",        188 + 256 *   0},      {"a-198",        198 + 256 *   0},
{"a-189",        189 + 256 *   0},      {"a-199",        199 + 256 *   0},

{"a-200",        200 + 256 *   0},      {"a-210",        210 + 256 *   0},      {"a-220",        220 + 256 *   0},      {"a-230",        230 + 256 *   0},
{"a-201",        201 + 256 *   0},      {"a-211",        211 + 256 *   0},      {"a-221",        221 + 256 *   0},      {"a-231",        231 + 256 *   0},
{"a-202",        202 + 256 *   0},      {"a-212",        212 + 256 *   0},      {"a-222",        222 + 256 *   0},      {"a-232",        232 + 256 *   0},
{"a-203",        203 + 256 *   0},      {"a-213",        213 + 256 *   0},      {"a-223",        223 + 256 *   0},      {"a-233",        233 + 256 *   0},
{"a-204",        204 + 256 *   0},      {"a-214",        214 + 256 *   0},      {"a-224",        224 + 256 *   0},      {"a-234",        234 + 256 *   0},
{"a-205",        205 + 256 *   0},      {"a-215",        215 + 256 *   0},      {"a-225",        225 + 256 *   0},      {"a-235",        235 + 256 *   0},
{"a-206",        206 + 256 *   0},      {"a-216",        216 + 256 *   0},      {"a-226",        226 + 256 *   0},      {"a-236",        236 + 256 *   0},
{"a-207",        207 + 256 *   0},      {"a-217",        217 + 256 *   0},      {"a-227",        227 + 256 *   0},      {"a-237",        237 + 256 *   0},
{"a-208",        208 + 256 *   0},      {"a-218",        218 + 256 *   0},      {"a-228",        228 + 256 *   0},      {"a-238",        238 + 256 *   0},
{"a-209",        209 + 256 *   0},      {"a-219",        219 + 256 *   0},      {"a-229",        229 + 256 *   0},      {"a-239",        239 + 256 *   0},

{"a-240",        240 + 256 *   0},      {"a-250",        250 + 256 *   0},
{"a-241",        241 + 256 *   0},      {"a-251",        251 + 256 *   0},
{"a-242",        242 + 256 *   0},      {"a-252",        252 + 256 *   0},
{"a-243",        243 + 256 *   0},      {"a-253",        253 + 256 *   0},
{"a-244",        244 + 256 *   0},      {"a-254",        254 + 256 *   0},
{"a-245",        245 + 256 *   0},      {"a-255",        255 + 256 *   0},
{"a-246",        246 + 256 *   0},
{"a-247",        247 + 256 *   0},
{"a-248",        248 + 256 *   0},
{"a-249",        249 + 256 *   0},

{"esc",           27 + 256 *   1},                                                                                      {"a-esc",          0 + 256 *   1},
{"1",            '1' + 256 *   2},      {"shreik",       '!' + 256 *   2},                                              {"a-1",            0 + 256 * 120},
{"2",            '2' + 256 *   3},      {"at",           '@' + 256 *   3},      {"c-2",            0 + 256 *   3},      {"a-2",            0 + 256 * 121},
{"3",            '3' + 256 *   4},      {"sharp",        '#' + 256 *   4},                                              {"a-3",            0 + 256 * 122},
{"4",            '4' + 256 *   5},      {"dollar",       '$' + 256 *   5},                                              {"a-4",            0 + 256 * 123},
{"5",            '5' + 256 *   6},      {"percent",      '%' + 256 *   6},                                              {"a-5",            0 + 256 * 124},
{"6",            '6' + 256 *   7},      {"circumflex",   '^' + 256 *   7},      {"c-6",           30 + 256 *   7},      {"a-6",            0 + 256 * 125},
{"7",            '7' + 256 *   8},      {"ampersand",    '&' + 256 *   8},                                              {"a-7",            0 + 256 * 126},
{"8",            '8' + 256 *   9},      {"star",         '*' + 256 *   9},                                              {"a-8",            0 + 256 * 127},
{"9",            '9' + 256 *  10},      {"lparen",       '(' + 256 *  10},                                              {"a-9",            0 + 256 * 128},
{"0",            '0' + 256 *  11},      {"rparen",       ')' + 256 *  11},                                              {"a-0",            0 + 256 * 129},
{"minus",        '-' + 256 *  12},      {"underbar",     '_' + 256 *  12},      {"c-minus",       31 + 256 *  12},      {"a-minus",        0 + 256 * 130},
{"equal",        '=' + 256 *  13},      {"plus",         '+' + 256 *  13},                                              {"a-equal",        0 + 256 * 131},
{"back",           8 + 256 *  14},                                              {"c-back",       127 + 256 *  14},      {"a-back",         0 + 256 *  14},
{"tab",            9 + 256 *  15},      {"s-tab",          0 + 256 *  15},      {"c-tab",          0 + 256 * 148},      {"a-tab",          0 + 256 * 165},
{"q",            'q' + 256 *  16},      {"s-q",          'Q' + 256 *  16},      {"c-q",           17 + 256 *  16},      {"a-q",            0 + 256 *  16},
{"w",            'w' + 256 *  17},      {"s-w",          'W' + 256 *  17},      {"c-w",           23 + 256 *  17},      {"a-w",            0 + 256 *  17},
{"e",            'e' + 256 *  18},      {"s-e",          'E' + 256 *  18},      {"c-e",            5 + 256 *  18},      {"a-e",            0 + 256 *  18},
{"r",            'r' + 256 *  19},      {"s-r",          'R' + 256 *  19},      {"c-r",           18 + 256 *  19},      {"a-r",            0 + 256 *  19},
{"t",            't' + 256 *  20},      {"s-t",          'T' + 256 *  20},      {"c-t",           20 + 256 *  20},      {"a-t",            0 + 256 *  20},
{"y",            'y' + 256 *  21},      {"s-y",          'Y' + 256 *  21},      {"c-y",           25 + 256 *  21},      {"a-y",            0 + 256 *  21},
{"u",            'u' + 256 *  22},      {"s-u",          'U' + 256 *  22},      {"c-u",           21 + 256 *  22},      {"a-u",            0 + 256 *  22},
{"i",            'i' + 256 *  23},      {"s-i",          'I' + 256 *  23},      {"c-i",            9 + 256 *  23},      {"a-i",            0 + 256 *  23},
{"o",            'o' + 256 *  24},      {"s-o",          'O' + 256 *  24},      {"c-o",           15 + 256 *  24},      {"a-o",            0 + 256 *  24},
{"p",            'p' + 256 *  25},      {"s-p",          'P' + 256 *  25},      {"c-p",           16 + 256 *  25},      {"a-p",            0 + 256 *  25},
{"lbracket",     '[' + 256 *  26},      {"lbrace",       '{' + 256 *  26},      {"c-lbracket",    27 + 256 *  26},      {"a-lbracket",     0 + 256 *  26},
{"rbracket",     ']' + 256 *  27},      {"rbrace",       '}' + 256 *  27},      {"c-rbracket",    29 + 256 *  27},      {"a-rbracket",     0 + 256 *  27},
{"enter",         13 + 256 *  28},                                              {"c-enter",       10 + 256 *  28},      {"a-enter",        0 + 256 *  28},
{"padenter",      13 + 256 * 224},                                              {"c-padenter",    10 + 256 * 224},      {"a-padenter",     0 + 256 * 166},

{"a",            'a' + 256 *  30},      {"s-a",          'A' + 256 *  30},      {"c-a",            1 + 256 *  30},      {"a-a",            0 + 256 *  30},
{"s",            's' + 256 *  31},      {"s-s",          'S' + 256 *  31},      {"c-s",           19 + 256 *  31},      {"a-s",            0 + 256 *  31},
{"d",            'd' + 256 *  32},      {"s-d",          'D' + 256 *  32},      {"c-d",            4 + 256 *  32},      {"a-d",            0 + 256 *  32},
{"f",            'f' + 256 *  33},      {"s-f",          'F' + 256 *  33},      {"c-f",            6 + 256 *  33},      {"a-f",            0 + 256 *  33},
{"g",            'g' + 256 *  34},      {"s-g",          'G' + 256 *  34},      {"c-g",            7 + 256 *  34},      {"a-g",            0 + 256 *  34},
{"h",            'h' + 256 *  35},      {"s-h",          'H' + 256 *  35},      {"c-h",            8 + 256 *  35},      {"a-h",            0 + 256 *  35},
{"j",            'j' + 256 *  36},      {"s-j",          'J' + 256 *  36},      {"c-j",           10 + 256 *  36},      {"a-j",            0 + 256 *  36},
{"k",            'k' + 256 *  37},      {"s-k",          'K' + 256 *  37},      {"c-k",           11 + 256 *  37},      {"a-k",            0 + 256 *  37},
{"l",            'l' + 256 *  38},      {"s-l",          'L' + 256 *  38},      {"c-l",           12 + 256 *  38},      {"a-l",            0 + 256 *  38},
{"semicolon",    ';' + 256 *  39},      {"colon",        ':' + 256 *  39},                                              {"a-semi",         0 + 256 *  39},
{"quote",       '\'' + 256 *  40},      {"doublequote",  '"' + 256 *  40},                                              {"a-quote",        0 + 256 *  40},
{"backquote",    '`' + 256 *  41},      {"tilde",        '~' + 256 *  41},                                              {"a-backquote",    0 + 256 *  41},

{"backslash",   '\\' + 256 *  43},      {"stile",        '|' + 256 *  43},      {"c-backslash",   28 + 256 *  43},      {"a-backslash",    0 + 256 *  43},
{"z",            'z' + 256 *  44},      {"s-z",          'Z' + 256 *  44},      {"c-z",           26 + 256 *  44},      {"a-z",            0 + 256 *  44},
{"x",            'x' + 256 *  45},      {"s-x",          'X' + 256 *  45},      {"c-x",           24 + 256 *  45},      {"a-x",            0 + 256 *  45},
{"c",            'c' + 256 *  46},      {"s-c",          'C' + 256 *  46},      {"c-c",            3 + 256 *  46},      {"a-c",            0 + 256 *  46},
{"v",            'v' + 256 *  47},      {"s-v",          'V' + 256 *  47},      {"c-v",           22 + 256 *  47},      {"a-v",            0 + 256 *  47},
{"b",            'b' + 256 *  48},      {"s-b",          'B' + 256 *  48},      {"c-b",            2 + 256 *  48},      {"a-b",            0 + 256 *  48},
{"n",            'n' + 256 *  49},      {"s-n",          'N' + 256 *  49},      {"c-n",           14 + 256 *  49},      {"a-n",            0 + 256 *  49},
{"m",            'm' + 256 *  50},      {"s-m",          'M' + 256 *  50},      {"c-m",           13 + 256 *  50},      {"a-m",            0 + 256 *  50},
{"comma",        ',' + 256 *  51},      {"lcaret",       '<' + 256 *  51},                                              {"a-comma",        0 + 256 *  51},
{"period",       '.' + 256 *  52},      {"rcaret",       '>' + 256 *  52},                                              {"a-period",       0 + 256 *  52},
{"slash",        '/' + 256 *  53},      {"query",        '?' + 256 *  53},                                              {"a-slash",        0 + 256 *  53},
{"padslash",     '/' + 256 * 224},                                              {"c-padslash",     0 + 256 * 149},      {"a-padslash",     0 + 256 * 164},

										{"c-prtsc",        0 + 256 * 114},
{"padstar",      '*' + 256 *  55},                                              {"c-padstar",      0 + 256 * 150},      {"a-padstar",      0 + 256 *  55},

{"space",        ' ' + 256 *  57},

{"f1",             0 + 256 *  59},      {"s-f1",           0 + 256 *  84},      {"c-f1",           0 + 256 *  94},      {"a-f1",           0 + 256 * 104},
{"f2",             0 + 256 *  60},      {"s-f2",           0 + 256 *  85},      {"c-f2",           0 + 256 *  95},      {"a-f2",           0 + 256 * 105},
{"f3",             0 + 256 *  61},      {"s-f3",           0 + 256 *  86},      {"c-f3",           0 + 256 *  96},      {"a-f3",           0 + 256 * 106},
{"f4",             0 + 256 *  62},      {"s-f4",           0 + 256 *  87},      {"c-f4",           0 + 256 *  97},      {"a-f4",           0 + 256 * 107},
{"f5",             0 + 256 *  63},      {"s-f5",           0 + 256 *  88},      {"c-f5",           0 + 256 *  98},      {"a-f5",           0 + 256 * 108},
{"f6",             0 + 256 *  64},      {"s-f6",           0 + 256 *  89},      {"c-f6",           0 + 256 *  99},      {"a-f6",           0 + 256 * 109},
{"f7",             0 + 256 *  65},      {"s-f7",           0 + 256 *  90},      {"c-f7",           0 + 256 * 100},      {"a-f7",           0 + 256 * 110},
{"f8",             0 + 256 *  66},      {"s-f8",           0 + 256 *  91},      {"c-f8",           0 + 256 * 101},      {"a-f8",           0 + 256 * 111},
{"f9",             0 + 256 *  67},      {"s-f9",           0 + 256 *  92},      {"c-f9",           0 + 256 * 102},      {"a-f9",           0 + 256 * 112},
{"f10",            0 + 256 *  68},      {"s-f10",          0 + 256 *  93},      {"c-f10",          0 + 256 * 103},      {"a-f10",          0 + 256 * 113},
{"f11",            0 + 256 * 133},      {"s-f11",          0 + 256 * 135},      {"c-f11",          0 + 256 * 137},      {"a-f11",          0 + 256 * 139},
{"f12",            0 + 256 * 134},      {"s-f12",          0 + 256 * 136},      {"c-f12",          0 + 256 * 138},      {"a-f12",          0 + 256 * 140},


{"home",           0 + 256 *  71},      {"s-home",       '7' + 256 *  71},      {"c-home",         0 + 256 * 119},
{"xhome",        224 + 256 *  71},                                              {"c-xhome",      224 + 256 * 119},      {"a-xhome",        0 + 256 * 151},

{"up",             0 + 256 *  72},      {"s-up",         '8' + 256 *  72},      {"c-up",           0 + 256 * 141},
{"xup",          224 + 256 *  72},                                              {"c-xup",        224 + 256 * 141},      {"a-xup",          0 + 256 * 152},

{"pgup",           0 + 256 *  73},      {"s-pgup",       '9' + 256 *  73},      {"c-pgup",         0 + 256 * 132},
{"xpgup",        224 + 256 *  73},                                              {"c-xpgup",      224 + 256 * 132},      {"a-xpgup",        0 + 256 * 153},

{"padminus",     '-' + 256 *  74},                                              {"c-padminus",     0 + 256 * 142},      {"a-padminus",     0 + 256 *  74},

{"left",           0 + 256 *  75},      {"s-left",       '4' + 256 *  75},      {"c-left",         0 + 256 * 115},
{"xleft",        224 + 256 *  75},                                              {"c-xleft",      224 + 256 * 115},      {"a-xleft",        0 + 256 * 155},

{"pad5",           0 + 256 *  76},      {"s-pad5",       '5' + 256 *  76},      {"c-pad5",         0 + 256 * 143},

{"right",          0 + 256 *  77},      {"s-right",      '6' + 256 *  77},      {"c-right",        0 + 256 * 116},
{"xright",       224 + 256 *  77},                                              {"c-xright",     224 + 256 * 116},      {"a-xright",       0 + 256 * 157},

{"padplus",      '+' + 256 *  78},                                              {"c-padplus",      0 + 256 * 144},      {"a-padplus",      0 + 256 *  78},

{"end",            0 + 256 *  79},      {"s-end",        '1' + 256 *  79},      {"c-end",          0 + 256 * 117},
{"xend",         224 + 256 *  79},                                              {"c-xend",       224 + 256 * 117},      {"a-xend",         0 + 256 * 159},

{"down",           0 + 256 *  80},      {"s-down",       '2' + 256 *  80},      {"c-down",         0 + 256 * 145},
{"xdown",        224 + 256 *  80},                                              {"c-xdown",      224 + 256 * 145},      {"a-xdown",        0 + 256 * 160},

{"pgdn",           0 + 256 *  81},      {"s-pgdn",       '3' + 256 *  81},      {"c-pgdn",         0 + 256 * 118},
{"xpgdn",        224 + 256 *  81},                                              {"c-xpgdn",      224 + 256 * 118},      {"a-xpgdn",        0 + 256 * 161},

{"ins",            0 + 256 *  82},      {"s-ins",        '0' + 256 *  82},      {"c-ins",          0 + 256 * 146},
{"xins",         224 + 256 *  82},                                              {"c-xins",       224 + 256 * 146},      {"a-xins",         0 + 256 * 162},

{"del",            0 + 256 *  83},      {"s-del",        '.' + 256 *  83},      {"c-del",          0 + 256 * 147},
{"xdel",         224 + 256 *  83},                                              {"c-xdel",       224 + 256 * 147},      {"a-xdel",         0 + 256 * 163},

	   };

#define NKEYS (sizeof(keys)/sizeof(struct KEY_STR))

/*********************************** MAIN *************************************/

void main(argc, argv)

unsigned argc;
char *argv[];

{
 unsigned int c = 0;
 struct KEY_STR *pkey;
 char *pname;
 int i;

 instints();		/* Handle Ctrl-Break, PrtSc	*/

 cprintf("Testing for enhanced keyboard... ");
 if(check_enh_keyb())	/* If we're on an enhanced keyboard, ... */
   {
    int16key = 0x10;	/* Use extended read key function code */
    int16kst = 0x11;	/* Use extended status	 function code */
    inst16();		/* Install INT 16h handler	*/
    inst16flg = 1;	/* Mark as installed		*/
    cprintf("found.\r\n");
   } /* End IF */
 else
    cprintf("not found.\r\n");

 cprintf("Space bar to exit\r\n");

 while((c & 0x00FF) != ' ')
      {
       c = getkey(); /* Get a keystroke */

       if(prtscflg)
	 {
	  prtscflg = 0;
	  pname = "prtsc";
	  cprintf("ASCII        key               keyname = %s\r\n",
						  pname 	   );
	 } /* End IF */
       else
       if(syscallflg)
	 {
	  syscallflg = 0;
	  pname = "sysreq";
	  cprintf("ASCII        key               keyname = %s\r\n",
						  pname 	   );
	 } /* End IF */
       else
	 {
	  pkey = &keys[0];
	  pname = "*** UNKNOWN ***";
	  for(i = 0; i < NKEYS; i++, pkey++)
	      if(c EQ pkey->code)
		{
		 pname = pkey->name;
		 break;
		} /* End IF */
	  cprintf("ASCII = %3d, key = %3d, %04Xh, keyname = %s\r\n",
		    c & 0x00FF,    c >> 8,     c, pname 	   );
	 } /* End ELSE */
      } /* End WHILE */

 if(inst16flg)		/* If we installed a handler before, ... */
    rest16();		/* Restore it			*/

 restints();		/* Restore interrupts		*/

} /* End MAIN */

