	 title	 KEYBINFO -- Get Keyboard Information
	 page	 58,122
	 name	 KEYBINFO

COMMENT|		Module Specifications

Environment:  IBM PC/AT, tested under DOS 3.20.

Segments, groups, and classes:
  Group PGROUP:
    Stack   segment STACK, byte-aligned, stack,  class 'prog'
    Program segment CODE,  byte-aligned, public, class 'prog'
    Data    segment DATA,  byte-aligned, public, class 'data'

Link requirements:  None, standalone .COM routine.

Program derived from:  None.

Original code by:  Bob Smith
		   Qualitas, Inc.
		   8314 Thoreau Dr.
		   Bethesda, MD  20817-3164
		   301-468-8848
		   March 1987

Modifications by:  None.

|
.xlist
	 include MASM.INC
	 include DOSCALL.INC
	 include ASCII.INC
	 include 8255.INC
	 include 8259.INC
.list

PGROUP	 group	 STACK,CODE,DATA

; The following segment both positions class 'prog' segments lower in
; memory than others so the first byte of the resulting .COM file is
; in the CODE segment, as well as satisfies the LINKer's need to have
; a stack segment.

STACK	 segment byte stack 'prog' ; Start STACK segment
STACK	 ends			; End STACK segment

DATA	 segment byte public 'data' ; Start DATA segment

@DIAG	 equ	 16+1+1+2	; # bytes of diagnostic information

	 public  RID_LO,RID_HI,RCMD,SELF,DIAGINFO,DIAGLEN
	 public  ICHK,RINP,ROUT,TINP,RSCAN,ASCAN
RID_LO	 db	 ?		; Low-order byte of Read ID byte
RID_HI	 db	 ?		; High-order ...
RCMD	 db	 ?		; Command byte
SELF	 db	 ?		; Self-test byte
DIAGINFO db	 @DIAG dup (?)	; Diagnostic information
DIAGLEN  dw	 ?		; # bytes actually received
ICHK	 db	 ?		; Interface check byte
RINP	 db	 ?		; Input port
ROUT	 db	 ?		; Output port
TINP	 db	 ?		; Test input
RSCAN	 db	 ?		; Read scan code set
ASCAN	 db	 ?		; Argument scan code set

@SCANLO  equ	 (mask $CMD_SYS) or (mask $CMD_OBFI)

	 public  SCANCMD
SCANCMD  db	 @SCANLO	; Command byte for scan code set 1
	 db	 (mask $CMD_CPAT) or @SCANLO ;			 2
	 db	 (mask $CMD_CPAT) or @SCANLO ;			 3

	 public  HEXTABLE
HEXTABLE db	 '0123456789ABCDEF' ; Hex to ASCII translate table

	 public  MSG_INIT,MSG_ERR_ARGS,MSG_ERR_PROG
MSG_INIT db	 'Enhanced keyboard information...',CR,LF,EOS
MSG_ERR_ARGS db  'Argument error:  value must be 1 to 3.',CR,LF,EOS
MSG_ERR_PROG db  "This system does not have a "
	 db	 "programmable keyboard.",CR,LF,EOS

	 public  LCL_FLG
LCL_FLG  dw	 0		; Local flags
@LCL_RID_LO equ  8000h		; Low-order Read ID byte
@LCL_RID_HI equ  4000h		; High-order Read ID byte
@LCL_RCMD equ	 2000h		; Command byte
@LCL_ICHK equ	 1000h		; Interface check
@LCL_RINP equ	 0800h		; Input port
@LCL_ROUT equ	 0400h		; Output port
@LCL_TINP equ	 0200h		; Test inputs
@LCL_SELF equ	 0100h		; Self test
@LCL_WCMD equ	 0080h		; Write command
@LCL_WOUT equ	 0040h		; Write output port
@LCL_RSCAN equ	 0020h		; Read scan code set
@LCL_WSCAN equ	 0010h		; Write scan code set
@LCL_ASCAN equ	 0008h		; Write argument scan code set
@LCL_ARGSCAN equ 0004h		; Scan code set argument

	 public  RIDMSG,RIDMSG_HI,RIDMSG_LO
RIDMSG	 db	 'Keyboard ID is '
RIDMSG_HI db	 '??'
RIDMSG_LO db	 '??.',CR,LF,EOS

	 public  RCMDMSG,RCMDMSG1
RCMDMSG  db	 'Command byte is '
RCMDMSG1 db	 '??.',CR,LF,EOS

	 public  SELFMSG,SELFMSG1
SELFMSG  db	 'Self-test byte is '
SELFMSG1 db	 '??.',CR,LF,EOS

	 public  ICHKMSG,ICHKMSG1
ICHKMSG  db	 'Interface check byte is '
ICHKMSG1 db	 '??.',CR,LF,EOS

	 public  DIAGMSG,DIAGMSG1
DIAGMSG  db	 'Diagnostic information is '
DIAGMSG1 db	 @DIAG dup ('??'),'.',CR,LF,EOS

	 public  RINPMSG,RINPMSG1
RINPMSG  db	 'Input port byte is '
RINPMSG1 db	 '??.',CR,LF,EOS

	 public  ROUTMSG,ROUTMSG1
ROUTMSG  db	 'Output port byte is '
ROUTMSG1 db	 '??.',CR,LF,EOS

	 public  TINPMSG,TINPMSG1
TINPMSG  db	 'Test input byte is '
TINPMSG1 db	 '??.',CR,LF,EOS

	 public  RSCANMSG,RSCANMSG1
RSCANMSG db	 'Scan code set is '
RSCANMSG1 db	 '??.',CR,LF,EOS

	 public  WCMDMSG_ACK,WCMDMSG_NAK,WCMDMSG_INV
WCMDMSG_ACK db	 'Write command byte of '
WCMDMSG_ACK1 db  '?? accepted.',CR,LF,EOS
WCMDMSG_NAK db	 'Write command byte of '
WCMDMSG_NAK1 db  '?? NOT accepted.',CR,LF,EOS
WCMDMSG_INV db	 'Command byte NOT supported.',CR,LF,EOS

	 public  WOUTMSG_ACK,WOUTMSG_NAK,WOUTMSG_INV
WOUTMSG_ACK db	 'Write output port byte of '
WOUTMSG_ACK1 db  '?? accepted.',CR,LF,EOS
WOUTMSG_NAK db	 'Write output port byte of '
WOUTMSG_NAK1 db  '?? NOT accepted.',CR,LF,EOS
WOUTMSG_INV db	 'Output port NOT supported.',CR,LF,EOS

	 public  WSCANMSG_ACK,WSCANMSG_NAK,WSCANMSG_INV
WSCANMSG_ACK db  'Write scan code set of '
WSCANMSG_ACK1 db '?? accepted.',CR,LF,EOS
WSCANMSG_NAK db  'Write scan code set of '
WSCANMSG_NAK1 db '?? NOT accepted.',CR,LF,EOS
WSCANMSG_INV db  'Scan code set NOT supported.',CR,LF,EOS

	 public  ASCANMSG_ACK,ASCANMSG_NAK,ASCANMSG_INV
ASCANMSG_ACK db  'Write argument scan code set of '
ASCANMSG_ACK1 db '?? accepted using command '
ASCANMSG_ACK2 db '??.',CR,LF,EOS
ASCANMSG_NAK db  'Write argument scan code set of '
ASCANMSG_NAK1 db '?? NOT accepted using command '
ASCANMSG_NAK2 db '??.',CR,LF,EOS
ASCANMSG_INV db  'Argument scan code set NOT supported.',CR,LF,EOS

DATA	 ends			; End DATA segment

CODE	 segment byte public 'prog' ; Start CODE segment
	 assume  cs:PGROUP

	 org	 100h		; Skip over PSP

	 NPPROC  KEYBINFO -- Get Keyboard Information
	 assume  ds:PGROUP,es:PGROUP

	 DOSCALL @STROUT,MSG_INIT ; Display initial message

	 call	 GETARGS	; See if there are any arguments

; In case the keyboard is programmable, disable it.
; If it's not programmable, the following won't hurt

; Disabling the keyboard has the effect of not generating any
; further data from the keyboard.

	 cli			; Nobody move
	 mov	 al,@S2C_DIS	; Disable the keyboard interface
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_PROG	; Not programmable

; Determine if the keyboard is programmable

	 mov	 al,@S2K_ECHO	; Send it an ECHO
	 call	 SEND6805	; Send to keyboard, response in AL
	 jc	 ERR_PROG	; Not programmable

	 cmp	 al,@K2S_ECHO	; Must be echoed
	 je	 KEYBINFO1	; Continue on
ERR_PROG:
	 DOSCALL @STROUT,MSG_ERR_PROG ; Display message
	 jmp	 ERROR_EXIT	; Join common error exit code

KEYBINFO1:
	 call	 GETRCMD	; Read command byte from controller
	 call	 GETRID 	; Read ID byte from keyboard
	 call	 GETICHK	; Perform interface test
	 call	 GETRINP	; Read controller's input port
	 call	 GETROUT	; Read controller's output port
	 call	 GETTINP	; Read test input byte
	 call	 GETRSCAN	; Read scan code set in use
	 call	 GETDIAG	; Perform diagnostic dump
	 call	 GETSELF	; Perform self-test (this command
				; resets the keyboard so we have to
				; reprogram it afterwards)
	 call	 PUTWCMD	; Reset controller's command byte
	 call	 PUTWOUT	; Reset controller's output port byte
	 call	 PUTWSCAN	; Reset keyboard's scan code set
	 call	 PUTASCAN	; Set keyboard's scan code set
				; if specified on command line

; Clear any pending EOIs and enable the keyboard again

	 call	 CLEAREOI	; Clear any keyboard EOI

	 mov	 al,@S2C_ENA	; Enable the keyboard interface
	 call	 SEND8042	; Send to keyboard controller
				; Ignore return code
ERROR_EXIT:
	 sti			; Allow interrupts

	 ret			; Return to DOS

	 assume  ds:nothing,es:nothing

KEYBINFO endp			; End KEYBINFO procedure
	 NPPROC  GETARGS -- Get Arguments
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Allowed arguments:

1	 =	 Switch to scan code set 1
2	 =	 ...			 2
3	 =	 ...			 3

|

	 REGSAVE <ax,si>	; Save registers

	 mov	 si,81h 	; DS:SI ==> command line
GETARGS_NEXT:
	 lodsb			; Get next character

	 cmp	 al,CR		; End of the line?
	 je	 GETARGS_EXIT	; Yes

	 cmp	 al,' '         ; Check for white space
	 je	 GETARGS_NEXT	; Go around again

	 cmp	 al,TAB 	; Check for white space
	 je	 GETARGS_NEXT	; Go around again

	 cmp	 al,'3'         ; Check against upper limit
	 ja	 GETARGS_ERR	; Too large

	 sub	 al,'0'         ; Check against lower limit
	 jbe	 GETARGS_ERR	; Too small

	 mov	 ASCAN,al	; Save for later use
	 or	 LCL_FLG,@LCL_ARGSCAN ; Mark as present
	 jmp	 short GETARGS_EXIT ; Join common exit code
GETARGS_ERR:
	 DOSCALL @STROUT,MSG_ERR_ARGS ; Tell the user

	 int	 20h		; Return to DOS
GETARGS_EXIT:
	 REGREST <si,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

GETARGS  endp			; End GETARGS procedure
	 NPPROC  GETRCMD -- Get Command Byte
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Read the command byte

|

	 REGSAVE <ax>		; Save register

	 cli			; Nobody move

	 call	 CLEAROBUF	; Wait for the output buffer to clear

	 mov	 al,@S2C_RCMD	; Read the controller's command byte
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_RCMD	; Something went wrong

	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 ERR_RCMD	; Something went wrong

	 mov	 RCMD,al	; Save response
	 or	 LCL_FLG,@LCL_RCMD ; Mark as present
ERR_RCMD:
	 call	 DISPRCMD	; Display the command byte

	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

GETRCMD  endp			; End GETRCMD procedure
	 NPPROC  GETRID -- Read Keyboard ID
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Read keyboard ID.

This value is returned in scan code format.  Thus to obtain the
actual value we need to turn off the controller's scan code
translation.

|

	 REGSAVE <ax>		; Save registers

	 cli			; Nobody move

	 call	 TRANSOFF	; Turn off scan code translation
	 jc	 ERR_RID2	; Something went wrong

	 mov	 al,@S2K_RID	; Function code to read ID
	 call	 SEND6805	; Send to keyboard, response in AL
	 jc	 ERR_RID1	; Jump if controller not responding

	 cmp	 al,@K2S_ACK	; Izit an ACK?
	 jne	 ERR_RID1	; Something went wrong

	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 ERR_RID1	; Something went wrong

	 mov	 RID_LO,al	; Save response
	 or	 LCL_FLG,@LCL_RID_LO ; Indicate we read it

	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 ERR_RID1	; Something went wrong

	 mov	 RID_HI,al	; Save response
	 or	 LCL_FLG,@LCL_RID_HI ; Mark as present
ERR_RID1:
	 call	 RESTCMD	; Restore original command byte
				; Ignore return code
ERR_RID2:
	 call	 DISPRID	; Format and display the ID bytes

	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

GETRID	 endp			; End GETRID procedure
	 NPPROC  GETDIAG -- Perform Diagnostic Dump
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Perform diagnostic dump.

These values are returned in scan code format.	Thus to obtain the
actual values we need to turn off the controller's scan code
translation.

|

	 REGSAVE <ax,cx,di>	; Save registers

	 cli			; Nobody move

	 mov	 cx,@DIAG	; # bytes expected

	 call	 TRANSOFF	; Turn off scan code translation
	 jc	 ERR_DIAG	; Something went wrong

	 lea	 di,DIAGINFO	; ES:DI ==> start of storage area

	 call	 CLEAROBUF	; Wait for the output buffer to clear

	 mov	 al,@S2C_DIAG	; Perform diagnostic dump
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_DIAG	; Something went wrong
DIAG_NEXT:
	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 ERR_DIAG	; Something went wrong

	 stosb			; Save response

	 loop	 DIAG_NEXT	; Jump if more bytes to display
ERR_DIAG:
	 call	 RESTCMD	; Restore original command byte
				; Ignore return code
	 neg	 cx		; Compute # bytes actually read
	 add	 cx,20
	 mov	 DIAGLEN,cx	; Save for DISPDIAG

	 call	 DISPDIAG	; Display the diagnostic info bytes

	 REGREST <di,cx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

GETDIAG  endp			; End GETDIAG procedure
	 NPPROC  GETICHK -- Perform Interface Check
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Perform interface check.

|

	 REGSAVE <ax>		; Save registers

	 cli			; Nobody move

	 call	 CLEAROBUF	; Wait for the output buffer to clear

	 mov	 al,@S2C_ICHK	; Perform interface check of
				; controller and keyboard
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_ICHK	; Something went wrong

	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 ERR_ICHK	; Something went wrong

	 mov	 ICHK,al	; Save response
	 or	 LCL_FLG,@LCL_ICHK ; Mark as present
ERR_ICHK:
	 call	 DISPICHK	; Display the interface check byte

	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

GETICHK  endp			; End GETICHK procedure
	 NPPROC  GETRINP -- Read Input Port
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Read controller's input port.

|

	 REGSAVE <ax>		; Save registers

	 cli			; Nobody move

	 call	 CLEAROBUF	; Wait for the output buffer to clear

	 mov	 al,@S2C_RINP	; Read controller's input port
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_RINP	; Something went wrong

	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 ERR_RINP	; Something went wrong

	 mov	 RINP,al	; Save response
	 or	 LCL_FLG,@LCL_RINP ; Mark as present
ERR_RINP:
	 call	 DISPRINP	; Display the input port byte

	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

GETRINP  endp			; End GETRINP procedure
	 NPPROC  GETROUT -- Read Output Port
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Read controller's output port.

|

	 REGSAVE <ax>		; Save registers

	 cli			; Nobody move

	 call	 CLEAROBUF	; Wait for the output buffer to clear

	 mov	 al,@S2C_ROUT	; Read controller's output port
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_ROUT	; Something went wrong

	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 ERR_ROUT	; Something went wrong

	 mov	 ROUT,al	; Save response
	 or	 LCL_FLG,@LCL_ROUT ; Mark as present
ERR_ROUT:
	 call	 DISPROUT	; Display the output port byte

	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

GETROUT  endp			; End GETROUT procedure
	 NPPROC  GETTINP -- Read Test Inputs
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Read controller's test inputs.

|

	 REGSAVE <ax>		; Save registers

	 cli			; Nobody move

	 call	 CLEAROBUF	; Wait for the output buffer to clear

	 mov	 al,@S2C_TINP	; Read controller's test inputs
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_TINP	; Something went wrong

	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 ERR_TINP	; Something went wrong

	 mov	 TINP,al	; Save response
	 or	 LCL_FLG,@LCL_TINP ; Mark as present
ERR_TINP:
	 call	 DISPTINP	; Display the test input byte

	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

GETTINP  endp			; End GETTINP procedure
	 NPPROC  GETRSCAN -- Read Current Scan Code Set
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Read current scan code set.

This value is returned in scan code format.  Thus to obtain the
actual value we need to turn off the controller's scan code
translation.


|

	 REGSAVE <ax>		; Save registers

	 cli			; Nobody move

	 call	 TRANSOFF	; Turn off scan code translation
	 jc	 ERR_RSCAN2	; Something went wrong

	 mov	 al,@S2K_SCAN	; Select scan code set
	 call	 SEND6805	; Send to keyboard, response in AL
	 jc	 ERR_RSCAN1	; Jump if controller not responding

	 cmp	 al,@K2S_ACK	; Izit an ACK?
	 jne	 ERR_RSCAN1	; Something went wrong

	 mov	 al,0		; Send it a request for current set
	 call	 SEND6805	; Send to keyboard, response in AL
	 jc	 ERR_RSCAN1	; Jump if controller not responding

	 cmp	 al,@K2S_ACK	; Izit an ACK?
	 jne	 ERR_RSCAN1	; Something went wrong

	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 ERR_RSCAN1	; Something went wrong

	 mov	 RSCAN,al	; Save response
	 or	 LCL_FLG,@LCL_RSCAN ; Indicate we read it
ERR_RSCAN1:
	 call	 RESTCMD	; Restore original command byte
				; Ignore return code
ERR_RSCAN2:
	 call	 DISPRSCAN	; Format and display the result

	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

GETRSCAN endp			; End GETRSCAN procedure
	 NPPROC  GETSELF -- Perform Self-test
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Perform self-test
This command resets the keyboard so we have to
reprogram it afterwards.

|

	 REGSAVE <ax>		; Save registers

	 cli			; Nobody move

	 call	 CLEAROBUF	; Wait for the output buffer to clear

	 mov	 al,@S2C_SELF	; Perform self-test of controller
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_SELF	; Something went wrong

	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 ERR_SELF	; Something went wrong

	 mov	 SELF,al	; Save response
	 or	 LCL_FLG,@LCL_SELF ; Mark as present
ERR_SELF:
	 call	 DISPSELF	; Display the self-test byte

	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

GETSELF  endp			; End GETSELF procedure
	 NPPROC  PUTWCMD -- Write Command Byte
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Write out the controller's command byte.

|

	 REGSAVE <ax,di>	; Save registers

	 cli			; Nobody move

	 test	 LCL_FLG,@LCL_RCMD ; Is RCMD valid?
	 jnz	 PUTWCMD1	; Yes

	 DOSCALL @STROUT,WCMDMSG_INV ; Tell the user

	 jmp	 short PUTWCMD_EXIT ; Join common exit code
PUTWCMD1:
	 mov	 al,@S2C_WCMD	; Write command byte
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_WCMD	; Something went wrong

	 call	 CLEARIBUF	; Wait for input buffer to clear
	 jc	 ERR_WCMD	; Error, controller not reading data

	 mov	 al,RCMD	; Send it the original command byte
	 lea	 di,WCMDMSG_ACK1 ; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
	 lea	 di,WCMDMSG_NAK1 ; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
	 out	 @8255_A,al	; Issue the command

	 or	 LCL_FLG,@LCL_WCMD ; Mark as done
ERR_WCMD:
	 call	 DISPWCMD	; Display message
PUTWCMD_EXIT:
	 REGREST <di,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

PUTWCMD  endp			; End PUTWCMD procedure
	 NPPROC  PUTWOUT -- Write Output Port
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Write the controller's output port.

|

	 REGSAVE <ax,di>	; Save registers

	 cli			; Nobody move

	 test	 LCL_FLG,@LCL_ROUT ; Is ROUT valid?
	 jnz	 PUTWOUT1	; Yes

	 DOSCALL @STROUT,WOUTMSG_INV ; Tell the user

	 jmp	 short PUTWOUT_EXIT ; Join common exit code
PUTWOUT1:
	 mov	 al,@S2C_WOUT	; Write output port byte
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_WOUT	; Something went wrong

	 call	 CLEARIBUF	; Wait for input buffer to clear
	 jc	 ERR_WOUT	; Error, controller not reading data

	 mov	 al,ROUT	; Send it the original byte
	 or	 al,10010000b	; Ensure 6805 data line high,
				; output buffer full
	 lea	 di,WOUTMSG_ACK1 ; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
	 lea	 di,WOUTMSG_NAK1 ; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI

	 out	 @8255_A,al	; Issue the command

	 or	 LCL_FLG,@LCL_WOUT ; Mark as done
ERR_WOUT:
	 call	 DISPWOUT	; Display message
PUTWOUT_EXIT:
	 REGREST <di,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

PUTWOUT  endp			; End PUTWOUT procedure
	 NPPROC  PUTWSCAN -- Write Scan Code Set
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Write current scan code set.

|

	 REGSAVE <ax,bx,di>	; Save registers

	 cli			; Nobody move

	 test	 LCL_FLG,@LCL_RSCAN ; Is RSCAN valid?
	 jnz	 PUTWSCAN1	; Yes

	 DOSCALL @STROUT,WSCANMSG_INV ; Tell the user

	 jmp	 short PUTWSCAN_EXIT ; Join common exit code
PUTWSCAN1:
	 mov	 al,@S2K_SCAN	; Select scan code set
	 call	 SEND6805	; Send to keyboard, response in AL
	 jc	 ERR_WSCAN	; Jump if controller not responding

	 cmp	 al,@K2S_ACK	; Izit an ACK?
	 jne	 ERR_WSCAN	; Something went wrong

	 mov	 al,RSCAN	; Restore orginal scan code set
	 lea	 di,WSCANMSG_ACK1 ; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
	 lea	 di,WSCANMSG_NAK1 ; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI

	 call	 SEND6805	; Send to keyboard, response in AL
	 jc	 ERR_WSCAN	; Jump if controller not responding

	 cmp	 al,@K2S_ACK	; Izit an ACK?
	 jne	 ERR_WSCAN	; Something went wrong

	 or	 LCL_FLG,@LCL_WSCAN ; Indicate we read it
ERR_WSCAN:
	 call	 DISPWSCAN	; Format and display the result
PUTWSCAN_EXIT:
	 REGREST <di,bx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

PUTWSCAN endp			; End PUTWSCAN procedure
	 NPPROC  PUTASCAN -- Write Argument Scan Code Set
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Write argument scan code set.

|

	 REGSAVE <ax,bx,di>	; Save registers

	 cli			; Nobody move

	 test	 LCL_FLG,@LCL_ARGSCAN ; Is ASCAN valid?
	 jz	 PUTASCAN_EXIT	; No

	 test	 LCL_FLG,@LCL_WSCAN ; Could we write it before?
	 jnz	 PUTASCAN1	; Yes

	 DOSCALL @STROUT,ASCANMSG_INV ; Tell the user

	 jmp	 short PUTASCAN_EXIT ; Join common exit code
PUTASCAN1:
	 mov	 al,@S2K_SCAN	; Select scan code set
	 call	 SEND6805	; Send to keyboard, response in AL
	 jc	 ERR_WSCAN	; Jump if controller not responding

	 cmp	 al,@K2S_ACK	; Izit an ACK?
	 jne	 ERR_WSCAN	; Something went wrong

	 mov	 al,ASCAN	; User's argument

	 xor	 bh,bh		; Zero to use as word
	 mov	 bl,al		; Copy to index register
	 mov	 bl,SCANCMD-1[bx] ; Get corresponding command byte

	 lea	 di,ASCANMSG_ACK1 ; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
	 lea	 di,ASCANMSG_NAK1 ; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI

	 call	 SEND6805	; Send to keyboard, response in AL
	 jc	 ERR_ASCAN	; Jump if controller not responding

	 cmp	 al,@K2S_ACK	; Izit an ACK?
	 jne	 ERR_ASCAN	; Something went wrong

	 or	 LCL_FLG,@LCL_ASCAN ; Indicate we sent it

; Send the appropriate command byte

	 mov	 al,@S2C_WCMD	; Write command byte
	 call	 SEND8042	; Send to keyboard controller
	 jc	 ERR_ASCAN	; Something went wrong

	 call	 CLEARIBUF	; Wait for input buffer to clear
	 jc	 ERR_ASCAN	; Error, controller not reading data

	 mov	 al,bl		; Send it the command byte
	 lea	 di,ASCANMSG_ACK2 ; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
	 lea	 di,ASCANMSG_NAK2 ; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI

	 out	 @8255_A,al	; Issue the command
ERR_ASCAN:
	 call	 DISPASCAN	; Format and display the result
PUTASCAN_EXIT:
	 REGREST <di,bx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

PUTASCAN endp			; End PUTASCAN procedure
	 NPPROC  TRANSOFF -- Turn Off Scan Code Translation
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Turn off scan code translation.

On exit:

CF	 =	 0 if all went well
	 =	 1 otherwise

|

	 REGSAVE <ax>		; Save register

	 test	 LCL_FLG,@LCL_RCMD ; Is RCMD valid?
	 stc			; Assume not
	 jz	 TRANSOFF_EXIT	; No

	 mov	 al,@S2C_WCMD	; Write command byte
	 call	 SEND8042	; Send to keyboard controller
	 jc	 TRANSOFF_EXIT	; Something went wrong

	 call	 CLEARIBUF	; Wait for input buffer to clear
	 jc	 TRANSOFF_EXIT	; Error, controller not reading data

; Turn off scan code translation

	 mov	 al,RCMD	; Get the original command byte
	 and	 al,not mask $CMD_CPAT
	 out	 @8255_A,al	; Issue the command
TRANSOFF_EXIT:
	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

TRANSOFF endp			; End TRANSOFF procedure
	 NPPROC  RESTCMD -- Restore Command Byte
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Restore command byte from RCMD.

On exit:

CF	 =	 0 if all went well
	 =	 1 otherwise

|

	 REGSAVE <ax>		; Save registers

	 mov	 al,@S2C_WCMD	; Write command byte
	 call	 SEND8042	; Send to keyboard controller
	 jc	 RESTCMD_EXIT	; Something went wrong

	 call	 CLEARIBUF	; Wait for input buffer to clear
	 jc	 RESTCMD_EXIT	; Error, controller not reading data

	 mov	 al,RCMD	; Get the original command byte
	 out	 @8255_A,al	; Issue the command
RESTCMD_EXIT:
	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

RESTCMD  endp			; End RESTCMD procedure
	 NPPROC  WAITRESP -- Wait For A Response
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Wait a response from the keyboard or its controller.

On exit:

CF	 =	 1 if no response
	 =	 0 otherwise

AL	 =	 response if CF=0
AH	 =	 clobbered

|

	 REGSAVE <bx,cx>	; Save registers

	 clc			; Assume all goes well
	 lahf			; Load AH with flags
	 pushf			; Save flags
	 cli			; Nobody move

; Wait for a response

	 mov	 bl,12		; Outer loop counter
				; (just to be safe on 16MHz 386)
	 xor	 cx,cx		; Inner loop counter
RESP1:
	 in	 al,@8042_ST	; Get status from keyboard

	 and	 al,mask $OUTFULL ; Check Output Buffer Full flag
	 loopz	 RESP1		; Jump if no response as yet
	 jz	 RESP2		; Still no response

	 jmp	 $+2		; Take into account I/O delay

	 in	 al,@8255_A	; Read in the code

	 jmp	 short RESP_EXIT ; Join common exit code
RESP2:
	 dec	 bl		; Try again
	 jnz	 RESP1		; Jump if more tries available

	 inc	 ah		; Set CF in AH
RESP_EXIT:
	 POPFF			; Restore flags with caller's IF
	 sahf			; Store AH into flags

	 REGREST <cx,bx>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

WAITRESP endp			; End WAITRESP procedure
	 NPPROC  SEND8042 -- Send Command To Keyboard Controller
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Send the command in AL to the keyboard controller port 64h.
There is no acknowledgement of this command.

On exit:

CF	 =	 1 if keyboard controller not responding
	 =	 0 otherwise

|

	 REGSAVE <ax>		; Save for a moment

	 clc			; Assume all goes well
	 lahf			; Load AH with flags
	 pushf			; Save flags
	 cli			; Nobody move

	 call	 CLEARIBUF	; Wait for input buffer to clear
	 jc	 CTRL_EXIT	; Jump if controller not responding

	 out	 @8042_ST,al	; Send the command
CTRL_EXIT:
	 adc	 ah,0		; Set CF in AH as necessary
	 POPFF			; Restore flags with caller's IF
	 sahf			; Store AH into flags

	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

SEND8042 endp			; End SEND8042 procedure
	 NPPROC  SEND6805 -- Send Data in AL to Keyboard
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Send AL to keyboard.

On exit:

CF	 =	 1 if timeout
	 =	 0 otherwise

AL	 =	 keyboard response if CF=0

AH is clobbered.

|

	 REGSAVE <cx>		; Save for a moment

	 mov	 cx,6		; # retries of resend

	 clc			; Assume all goes well
	 lahf			; Load AH with flags
	 pushf			; Save flags
	 cli			; Nobody move
SEND0:
	 REGSAVE <ax>		; Save for a moment

	 call	 CLEARIBUF	; Wait for input buffer to clear
	 jc	 SEND1		; Error, controller not reading data
				; (note CF=1)
	 out	 @8255_A,al	; Issue the command

	 call	 WAITRESP	; Wait for a response, returned in AL
	 jc	 SEND1		; Something went wrong

	 cmp	 al,@K2S_RESEND ; Izit a resend?
	 clc			; In case it isn't
	 jne	 SEND1		; No

	 REGREST <ax>		; Restore

	 loop	 SEND0		; Jump if more retries

	 stc			; Indicate something went wrong

	 REGSAVE <ax>		; Save for a moment
SEND1:
	 inc	 sp		; Restore stack pointer
	 inc	 sp		; ...without changing CF

	 adc	 ah,0		; Set CF in AH as necessary
	 POPFF			; Restore flags with caller's IF
	 sahf			; Store AH into flags

	 REGREST <cx>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

SEND6805 endp			; End SEND6805 procedure
	 NPPROC  CLEARIBUF -- Wait For The Input Buffer To Clear
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Wait for the one-byte input buffer to clear.

On exit:

CF	 =	 0 if buffer empty
	 =	 1 otherwise

|


	 REGSAVE <ax,cx>	; Save registers

	 clc			; Assume all goes well
	 lahf			; Load AH with flags
	 pushf			; Save flags
	 cli			; Nobody move

	 xor	 cx,cx		; Loop counter
CLEARIBUF1:
	 in	 al,@8042_ST	; Get status from keyboard

	 and	 al,mask $INPFULL ; Check Input Buffer Full flag
	 loopnz  CLEARIBUF1	; Last char not read as yet
	 jz	 CLEARIBUF_EXIT ; Jump if buffer clear before then
				; (note CF=0)
	 stc			; Mark as in error
CLEARIBUF_EXIT:
	 adc	 ah,0		; Set CF in AH as necessary
	 POPFF			; Restore flags with caller's IF
	 sahf			; Store AH into flags

	 REGREST <cx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

CLEARIBUF endp			; End CLEARIBUF procedure
	 NPPROC  CLEAROBUF -- Wait For The Output Buffer To Clear
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Wait for the one-byte input buffer to clear.

|


	 REGSAVE <ax>		; Save register

	 cli			; Nobody move
CLEAROBUF1:
	 in	 al,@8042_ST	; Get status from keyboard

	 and	 al,mask $OUTFULL ; Check Output Buffer Full flag
	 jz	 CLEAROBUF_EXIT ; Jump if buffer clear before

	 jmp	 $+2		; I/O delay

	 in	 al,@8255_A	; Purge the character

	 jmp	 CLEAROBUF1	; Continue on
CLEAROBUF_EXIT:
	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

CLEAROBUF endp			; End CLEAROBUF procedure
	 NPPROC  CLEAREOI -- Clear Any Keyboard EOI
	 assume  ds:nothing,es:nothing
COMMENT|

Clear any IRQ1 in the 8259.

|

	 REGSAVE <ax>		; Save registers

	 mov	 al,@EOI1	; Get specific EOI for IRQ1
	 out	 @ICR,al	; Send to 8259

	 REGREST <ax>		; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

CLEAREOI endp			; End CLEAREOI procedure
	 NPPROC  FMTSAVE -- Format AL and Save in ES:DI
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Format AL as two hex digits and save them in ES:DI and ES:DI+1.

ES:DI updated on exit.

|

	 REGSAVE <ax,bx,cx>	; Save registers

	 lea	 bx,HEXTABLE	; DS:BX ==> translate table

	 xor	 ah,ah		; Zero to use as word
	 mov	 cl,4		; # bits in one digit
	 shl	 ax,cl		; Shift high-order digit to AH
	 shr	 al,cl		; Shift low-order digit to AL

	 xchg	 al,ah		; Swap to do high-order digit first
	 xlat	 HEXTABLE	; Translate digit
	 stosb			; Save in message

	 mov	 al,ah		; Copy other digit
	 xlat	 HEXTABLE	; Translate digit
	 stosb			; Save in message

	 REGREST <cx,bx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

FMTSAVE  endp			; End FMTSAVE procedure
	 NPPROC  DISPRID -- Display Read ID Bytes
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display Read ID byte

|

	 REGSAVE <ax,dx,di>	; Save registers

	 test	 LCL_FLG,@LCL_RID_LO ; Did we read anything?
	 jz	 DISPRID1	; No

	 mov	 al,RID_LO	; Get low-order byte of Read ID
	 lea	 di,RIDMSG_LO	; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
DISPRID1:
	 test	 LCL_FLG,@LCL_RID_HI ; Did we read anything?
	 jz	 DISPRID2	; No

	 mov	 al,RID_HI	; Get high-order byte of Read ID
	 lea	 di,RIDMSG_HI	; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
DISPRID2:
	 DOSCALL @STROUT,RIDMSG ; Display message

	 REGREST <di,dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPRID  endp			; End DISPRID procedure
	 NPPROC  DISPRCMD -- Display Command Byte
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display Command byte

|

	 REGSAVE <ax,dx,di>	; Save registers

	 test	 LCL_FLG,@LCL_RCMD ; Did we read anything?
	 jz	 DISPRCMD1	; No

	 mov	 al,RCMD	; Get Command byte
	 lea	 di,RCMDMSG1	; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
DISPRCMD1:
	 DOSCALL @STROUT,RCMDMSG ; Display message

	 REGREST <di,dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPRCMD endp			; End DISPRCMD procedure
	 NPPROC  DISPSELF -- Display Self-test Byte
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display self-test byte

|

	 REGSAVE <ax,dx,di>	; Save registers

	 test	 LCL_FLG,@LCL_SELF ; Did we read anything?
	 jz	 DISPSELF1	; No

	 mov	 al,SELF	; Get self-test byte
	 lea	 di,SELFMSG1	; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
DISPSELF1:
	 DOSCALL @STROUT,SELFMSG ; Display message

	 REGREST <di,dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPSELF endp			; End DISPSELF procedure
	 NPPROC  DISPICHK -- Display Interface Check Byte
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display interface check byte

|

	 REGSAVE <ax,dx,di>	; Save registers

	 test	 LCL_FLG,@LCL_ICHK ; Did we read anything?
	 jz	 DISPICHK1	; No

	 mov	 al,ICHK	; Get interface check byte
	 lea	 di,ICHKMSG1	; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
DISPICHK1:
	 DOSCALL @STROUT,ICHKMSG ; Display message

	 REGREST <di,dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPICHK endp			; End DISPICHK procedure
	 NPPROC  DISPDIAG -- Display Diagnostic Bytes
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display diagnostic bytes

|

	 REGSAVE <ax,cx,dx,si,di> ; Save registers

	 lea	 si,DIAGINFO	; DS:SI ==> save area for diag info
	 lea	 di,DIAGMSG1	; ES:DI ==> place to store
	 mov	 cx,DIAGLEN	; # bytes actually read
	 jcxz	 DISPDIAG2	; Jump if none read
DISPDIAG1:
	 lodsb			; Get next diagnostic byte
	 call	 FMTSAVE	; Format and save it in ES:DI

	 loop	 DISPDIAG1	; Jump if more to display
DISPDIAG2:
	 DOSCALL @STROUT,DIAGMSG ; Display message

	 REGREST <di,si,dx,cx,ax> ; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPDIAG endp			; End DISPDIAG procedure
	 NPPROC  DISPRINP -- Display Input Port Byte
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display input port byte

|

	 REGSAVE <ax,dx,di>	; Save registers

	 test	 LCL_FLG,@LCL_RINP ; Did we read anything?
	 jz	 DISPRINP1	; No

	 mov	 al,RINP	; Get input port byte
	 lea	 di,RINPMSG1	; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
DISPRINP1:
	 DOSCALL @STROUT,RINPMSG ; Display message

	 REGREST <di,dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPRINP endp			; End DISPRINP procedure
	 NPPROC  DISPROUT -- Display Output Port Byte
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display output port byte

|

	 REGSAVE <ax,dx,di>	; Save registers

	 test	 LCL_FLG,@LCL_ROUT  ; Did we read anything?
	 jz	 DISPROUT1	; No

	 mov	 al,ROUT	; Get output port byte
	 lea	 di,ROUTMSG1	; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
DISPROUT1:
	 DOSCALL @STROUT,ROUTMSG ; Display message

	 REGREST <di,dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPROUT endp			; End DISPROUT procedure
	 NPPROC  DISPTINP -- Display Test Input Byte
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display test input byte

|

	 REGSAVE <ax,dx,di>	; Save registers

	 test	 LCL_FLG,@LCL_TINP ; Did we read anything?
	 jz	 DISPTINP1	; No

	 mov	 al,TINP	; Get test input byte
	 lea	 di,TINPMSG1	; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
DISPTINP1:
	 DOSCALL @STROUT,TINPMSG ; Display message

	 REGREST <di,dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPTINP endp			; End DISPTINP procedure
	 NPPROC  DISPRSCAN -- Display Scan Code Set In Use
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display scan code set in use

|

	 REGSAVE <ax,dx,di>	; Save registers

	 test	 LCL_FLG,@LCL_RSCAN ; Did we read anything?
	 jz	 DISPRSCAN1	; No

	 mov	 al,RSCAN	; Get scan code set byte
	 lea	 di,RSCANMSG1	; ES:DI ==> place to store
	 call	 FMTSAVE	; Format and save it in ES:DI
DISPRSCAN1:
	 DOSCALL @STROUT,RSCANMSG ; Display message

	 REGREST <di,dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPRSCAN endp			; End DISPRSCAN procedure
	 NPPROC  DISPWCMD -- Display Write Command Status
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display status of writing command byte

|

	 REGSAVE <ax,dx>	; Save registers

	 test	 LCL_FLG,@LCL_WCMD ; Did we do it?
	 jz	 DISPWCMD1	; No

	 DOSCALL @STROUT,WCMDMSG_ACK ; Display message
	 jmp	 short DISPWCMD2 ; Join common exit code
DISPWCMD1:
	 DOSCALL @STROUT,WCMDMSG_NAK ; Display message
DISPWCMD2:
	 REGREST <dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPWCMD endp			; End DISPWCMD procedure
	 NPPROC  DISPWOUT -- Display Write Output Port Status
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display status of writing output port byte

|

	 REGSAVE <ax,dx>	; Save registers

	 test	 LCL_FLG,@LCL_WOUT ; Did we do it?
	 jz	 DISPWOUT1	; No

	 DOSCALL @STROUT,WOUTMSG_ACK ; Display message
	 jmp	 short DISPWOUT2 ; Join common exit code
DISPWOUT1:
	 DOSCALL @STROUT,WOUTMSG_NAK ; Display message
DISPWOUT2:
	 REGREST <dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPWOUT endp			; End DISPWOUT procedure
	 NPPROC  DISPWSCAN -- Display Scan Code Set Status
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display status of writing scan code set

|

	 REGSAVE <ax,dx>	; Save registers

	 test	 LCL_FLG,@LCL_WSCAN ; Did we do it?
	 jz	 DISPWSCAN1	; No

	 DOSCALL @STROUT,WSCANMSG_ACK ; Display message
	 jmp	 short DISPWSCAN2 ; Join common exit code
DISPWSCAN1:
	 DOSCALL @STROUT,WSCANMSG_NAK ; Display message
DISPWSCAN2:
	 REGREST <dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPWSCAN endp			; End DISPWSCAN procedure
	 NPPROC  DISPASCAN -- Display Scan Code Set Status
	 assume  ds:PGROUP,es:PGROUP
COMMENT|

Display status of writing scan code set

|

	 REGSAVE <ax,dx>	; Save registers

	 test	 LCL_FLG,@LCL_ASCAN ; Did we do it?
	 jz	 DISPASCAN1	; No

	 DOSCALL @STROUT,ASCANMSG_ACK ; Display message
	 jmp	 short DISPASCAN2 ; Join common exit code
DISPASCAN1:
	 DOSCALL @STROUT,ASCANMSG_NAK ; Display message
DISPASCAN2:
	 REGREST <dx,ax>	; Restore

	 ret			; Return to caller

	 assume  ds:nothing,es:nothing

DISPASCAN endp			; End DISPASCAN procedure

CODE	 ends			; End CODE segment

	 MEND	 KEYBINFO	; End KEYBINFO module
