COMMENT|   MASM Macros	 |

.xcref REGSAVE,REGREST,NPROC,NPPROC,FPROC,FPPROC,MEND,REPMOVSB,MJ,POPFF
.xcref FCALL,OLDINT,REPMOVSF,SMAX,SMIN,UMAX,UMIN
	 if1
REGSAVE  macro	 LIST		; Register save macro

	 irp	 XX,<LIST>
	 push	 XX
	 endm

	 endm			; REGSAVE

REGREST  macro	 LIST		; Register restore macro

	 irp	 XX,<LIST>
	 pop	 XX
	 endm

	 endm			; REGREST

NPROC	 macro	 @PROC,@T1,@T2,@T3,@T4,@T5,@T6,@T7,@T8,@T9,@T10
	 subttl  @PROC Procedure @T1 @T2 @T3 @T4 @T5 @T6 @T7 @T8 @T9 @T10
	 page
@PROC	 proc	 near
	 endm			; NPROC

NPPROC	 macro	 @PROC,@T1,@T2,@T3,@T4,@T5,@T6,@T7,@T8,@T9,@T10
	 subttl  @PROC Procedure @T1 @T2 @T3 @T4 @T5 @T6 @T7 @T8 @T9 @T10
	 page
	 public  @PROC
@PROC	 proc	 near
	 endm			; NPPROC

FPROC	 macro	 @PROC,@T1,@T2,@T3,@T4,@T5,@T6,@T7,@T8,@T9,@T10
	 subttl  @PROC Procedure @T1 @T2 @T3 @T4 @T5 @T6 @T7 @T8 @T9 @T10
	 page
@PROC	 proc	 far
	 endm			; FPROC

FPPROC	 macro	 @PROC,@T1,@T2,@T3,@T4,@T5,@T6,@T7,@T8,@T9,@T10
	 subttl  @PROC Procedure @T1 @T2 @T3 @T4 @T5 @T6 @T7 @T8 @T9 @T10
	 page
	 public  @PROC
@PROC	 proc	 far
	 endm			; FPPROC

MEND	 macro	 @START

	 if1
%OUT Pass 1 complete
	 else
%OUT Pass 2 complete
	 endif

	 end	 @START

	 endm			; MEND

REPMOVSB macro	 DIR
	 local	 L1,L2

	 pushf

	 ifb	 <DIR>
	 shr	 cx,1		; Move forwards
	 jnc	 L1

	 movsb
L1:
	 rep	 movsw

	 else
	 ifdif	 <DIR>,<STD>
%OUT Invalid REPMOVSB argument DIR.
	 else

	 dec	 si
	 dec	 di

	 shr	 cx,1		; Move backwards
	 jz	 L1
	 rep	 movsw
L1:
	 jnc	 L2

	 inc	 si
	 inc	 di
	 movsb
L2:
	 endif			; IFDIF
	 endif			; IFB
	 POPFF

	 endm			; REPMOVSB

REPMOVSF macro	 DIR
	 local	 L1,L2

	 ifb	 <DIR>
	 shr	 cx,1		; Move forwards
	 jnc	 L1

	 movsb
L1:
     rep movsw

	 else
	 ifdif	 <DIR>,<STD>
%OUT Invalid REPMOVSF argument DIR.
	 else

	 dec	 si
	 dec	 di

	 shr	 cx,1		; Move backwards
	 jz	 L1
     rep movsw
L1:
	 jnc	 L2

	 inc	 si
	 inc	 di
	 movsb
L2:
	 endif			; IFDIF
	 endif			; IFB

	 endm			; REPMOVSF

MJ	 macro	 CC,LAB,DEB	; Macro for long jumps
	 local	 L1

MJ_NOT	 =	 0

	 irpc	 X,<CC>
	 ifidn	 <X>,<n>
MJ_NOT	 =	 1
	 else
	 ifidn	 <X>,<N>
MJ_NOT	 =	 1
	 endif			; IFIDN
	 endif			; IFIDN
	 endm			; IRP

	 if	 MJ_NOT 	; If original jump is a NOT

	 irpc	 XX,<CC>
	 ife	 MJ_NOT
	 j&&XX	 L1
	 else
MJ_NOT	 =	 MJ_NOT-1
	 endif			; IFE
	 endm			; IRP

	 else
	 jn&CC	 L1
	 endif			; IF

	 ifnb	 <DEB>
	 int	 03h		;; Call debugger
	 endif			; IFNB

	 jmp	 LAB
L1:
	 endm			; MJ

SMIN	 macro	 A,B		; A <== signed minimum of A and B
	 local	 L1

	 cmp	 A,B
	 jle	 L1

	 mov	 A,B
L1:
	 endm			; SMIN

UMIN	 macro	 A,B		; A <== unsigned minimum of A and B
	 local	 L1

	 cmp	 A,B
	 jbe	 L1

	 mov	 A,B
L1:
	 endm			; UMIN

SMAX	 macro	 A,B		; A <== signed maximum of A and B
	 local	 L1

	 cmp	 A,B
	 jge	 L1

	 mov	 A,B
L1:
	 endm			; SMAX

UMAX	 macro	 A,B		; A <== unsigned maximum of A and B
	 local	 L1

	 cmp	 A,B
	 jae	 L1

	 mov	 A,B
L1:
	 endm			; UMAX

POPFF	 macro
	 local	 L1,L2

	 jmp	 short L2
L1:
	 iret
L2:
	 push	 cs
	 call	 L1

	 endm			; POPFF

OLDINT	 macro	 NN

	 pushf			;; Pass flags as in INT call
	 cli			;; Duplicate INT calling environment
	 call	 OLDINT&NN&_VEC ;; Call original interrupt handler

	 endm			;; OLDINT

FCALL	 macro	 NAME

	 push	 cs
	 call	 near ptr NAME

	 endm			; FCALL

	 endif			; IF1 ******************************

.xcref VECTOR
VECTOR	 struc

VOFF	 dw	 ?		; Offset
VSEG	 dw	 ?		; Segment

VECTOR	 ends

